(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ngx-logger'), require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-logger/testing', ['exports', 'ngx-logger', '@angular/core', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ngx-logger'] = global['ngx-logger'] || {}, global['ngx-logger'].testing = {}), global['ngx-logger'], global.ng.core, global.rxjs));
}(this, (function (exports, ngxLogger, core, rxjs) { 'use strict';

    var NGXLoggerConfigEngineMock = /** @class */ (function () {
        function NGXLoggerConfigEngineMock() {
        }
        Object.defineProperty(NGXLoggerConfigEngineMock.prototype, "level", {
            get: function () {
                return ngxLogger.NgxLoggerLevel.ERROR;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NGXLoggerConfigEngineMock.prototype, "serverLogLevel", {
            get: function () {
                return ngxLogger.NgxLoggerLevel.OFF;
            },
            enumerable: false,
            configurable: true
        });
        NGXLoggerConfigEngineMock.prototype.updateConfig = function (config) {
        };
        NGXLoggerConfigEngineMock.prototype.getConfig = function () {
            return { level: ngxLogger.NgxLoggerLevel.ERROR };
        };
        return NGXLoggerConfigEngineMock;
    }());
    NGXLoggerConfigEngineMock.decorators = [
        { type: core.Injectable }
    ];

    // todo bmtheo, there should be an interface or something to make sure this mock sticks to the real API
    var NGXLoggerMock = /** @class */ (function () {
        function NGXLoggerMock() {
        }
        Object.defineProperty(NGXLoggerMock.prototype, "level", {
            get: function () {
                return ngxLogger.NgxLoggerLevel.ERROR;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(NGXLoggerMock.prototype, "serverLogLevel", {
            get: function () {
                return ngxLogger.NgxLoggerLevel.OFF;
            },
            enumerable: false,
            configurable: true
        });
        NGXLoggerMock.prototype.trace = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.debug = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.info = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.log = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.warn = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.error = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.fatal = function (message) {
            var additional = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                additional[_i - 1] = arguments[_i];
            }
        };
        NGXLoggerMock.prototype.updateConfig = function (config) {
        };
        NGXLoggerMock.prototype.setCustomHttpHeaders = function (headers) {
        };
        NGXLoggerMock.prototype.setCustomParams = function (params) {
        };
        NGXLoggerMock.prototype.registerMonitor = function (monitor) {
        };
        NGXLoggerMock.prototype.setWithCredentialsOptionValue = function (withCredentials) {
        };
        NGXLoggerMock.prototype.getConfigSnapshot = function () {
            return { level: ngxLogger.NgxLoggerLevel.ERROR };
        };
        return NGXLoggerMock;
    }());
    NGXLoggerMock.decorators = [
        { type: core.Injectable }
    ];

    /**
     * CustomNGXLoggerServiceMock is a mock for CustomNGXLoggerService
     */
    var CustomNGXLoggerServiceMock = /** @class */ (function () {
        function CustomNGXLoggerServiceMock() {
        }
        CustomNGXLoggerServiceMock.prototype.create = function () {
            return new NGXLoggerMock();
        };
        return CustomNGXLoggerServiceMock;
    }());
    CustomNGXLoggerServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var NGXLoggerMapperServiceMock = /** @class */ (function () {
        function NGXLoggerMapperServiceMock() {
        }
        NGXLoggerMapperServiceMock.prototype.getLogPosition = function (config, metadata) {
            return rxjs.of({ fileName: 'test.ts' });
        };
        return NGXLoggerMapperServiceMock;
    }());
    NGXLoggerMapperServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var NGXLoggerMetadataServiceMock = /** @class */ (function () {
        function NGXLoggerMetadataServiceMock() {
        }
        NGXLoggerMetadataServiceMock.prototype.getMetadata = function (level, config, message, additional) {
            return {
                level: level
            };
        };
        return NGXLoggerMetadataServiceMock;
    }());
    NGXLoggerMetadataServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var NGXLoggerRulesServiceMock = /** @class */ (function () {
        function NGXLoggerRulesServiceMock() {
        }
        NGXLoggerRulesServiceMock.prototype.shouldCallWriter = function (level, config, message, additional) {
            return false;
        };
        NGXLoggerRulesServiceMock.prototype.shouldCallServer = function (level, config, message, additional) {
            return false;
        };
        NGXLoggerRulesServiceMock.prototype.shouldCallMonitor = function (level, config, message, additional) {
            return false;
        };
        return NGXLoggerRulesServiceMock;
    }());
    NGXLoggerRulesServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var NGXLoggerServerServiceMock = /** @class */ (function () {
        function NGXLoggerServerServiceMock() {
        }
        NGXLoggerServerServiceMock.prototype.sendToServer = function (metadata, config) {
        };
        return NGXLoggerServerServiceMock;
    }());
    NGXLoggerServerServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var NGXLoggerWriterServiceMock = /** @class */ (function () {
        function NGXLoggerWriterServiceMock() {
        }
        NGXLoggerWriterServiceMock.prototype.writeMessage = function (metadata, config) {
        };
        return NGXLoggerWriterServiceMock;
    }());
    NGXLoggerWriterServiceMock.decorators = [
        { type: core.Injectable }
    ];

    var ɵ0 = { level: ngxLogger.NgxLoggerLevel.ERROR };
    var LoggerTestingModule = /** @class */ (function () {
        function LoggerTestingModule() {
        }
        return LoggerTestingModule;
    }());
    LoggerTestingModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [ngxLogger.LoggerModule],
                    providers: [
                        { provide: ngxLogger.NGXLogger, useClass: NGXLoggerMock },
                        { provide: ngxLogger.TOKEN_LOGGER_CONFIG, useValue: ɵ0 },
                        { provide: ngxLogger.TOKEN_LOGGER_CONFIG_ENGINE, useClass: NGXLoggerConfigEngineMock },
                        { provide: ngxLogger.TOKEN_LOGGER_METADATA_SERVICE, useClass: NGXLoggerMetadataServiceMock },
                        { provide: ngxLogger.TOKEN_LOGGER_RULES_SERVICE, useClass: NGXLoggerRulesServiceMock },
                        { provide: ngxLogger.TOKEN_LOGGER_MAPPER_SERVICE, useClass: NGXLoggerMapperServiceMock },
                        { provide: ngxLogger.TOKEN_LOGGER_WRITER_SERVICE, useClass: NGXLoggerWriterServiceMock },
                        { provide: ngxLogger.TOKEN_LOGGER_SERVER_SERVICE, useClass: NGXLoggerServerServiceMock },
                        { provide: ngxLogger.CustomNGXLoggerService, useClass: CustomNGXLoggerServiceMock },
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CustomNGXLoggerServiceMock = CustomNGXLoggerServiceMock;
    exports.LoggerTestingModule = LoggerTestingModule;
    exports.NGXLoggerConfigEngineMock = NGXLoggerConfigEngineMock;
    exports.NGXLoggerMapperServiceMock = NGXLoggerMapperServiceMock;
    exports.NGXLoggerMetadataServiceMock = NGXLoggerMetadataServiceMock;
    exports.NGXLoggerMock = NGXLoggerMock;
    exports.NGXLoggerRulesServiceMock = NGXLoggerRulesServiceMock;
    exports.NGXLoggerServerServiceMock = NGXLoggerServerServiceMock;
    exports.NGXLoggerWriterServiceMock = NGXLoggerWriterServiceMock;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-logger-testing.umd.js.map
